---
title: Reserved IPs
url: https://docs.vultr.com/products/compute/instances/cloud-compute/networking/reserved-ips
description: A feature that allows you to assign permanent IP addresses to your Vultr instances that remain available even when the instance is destroyed.
publish_date: 2024-09-23T20:19:57.906402Z
last_updated: 2026-05-26T18:43:12.482731Z
---

# How to Attach Reserved IPs to a Vultr Cloud Compute Instance

Reserved IPs allow you to reserve a specific public IP address you can assign to a Vultr Cloud Compute instance. You can attach multiple reserved IPs to a single instance to enable advanced networking capabilities like routing and IP forwarding with distinct public IP addresses.

Follow this guide to attach reserved IPs on a Vultr Cloud Compute instance using the Vultr Console, API, CLI, or Terraform.

=== "Vultr Console"

    1. Navigate to **Products**, expand the **Network** group and click **Reserved IPs**.
    1. Click your target reserved IP to open its management page.
    1. Click the **Attach to Server** drop-down and select your target Vultr Cloud Compute instance.
    1. Click **Attach** to apply the reserved IP to the Vultr Cloud Compute instance.

=== "Vultr API"

    1. Send a `GET` request to the [**List Instances** endpoint](https://www.vultr.com/api/#tag/instances/operation/list-instances) and note your target instance's ID.

        ```console
        $ curl "https://api.vultr.com/v2/instances" \
          -X GET \
          -H "Authorization: Bearer ${VULTR_API_KEY}"
        ```

    1. Send a `GET` request to the [**List Reserved IPs** endpoint](https://www.vultr.com/api/#tag/reserved-ip/operation/list-reserved-ips) and note the target reserved IP's ID.

        ```console
        $ curl "https://api.vultr.com/v2/reserved-ips" \
           -X GET \
           -H "Authorization: Bearer ${VULTR_API_KEY}"
        ```

    1. Send a `POST` request to the [**Attach Reserved IP** endpoint](https://www.vultr.com/api/#tag/reserved-ip/operation/attach-reserved-ip) to attach the reserved IP to the instance.

        ```console
        $ curl "https://api.vultr.com/v2/reserved-ips/{reserved-ip}/attach" \
          -X POST \
          -H "Authorization: Bearer ${VULTR_API_KEY}" \
          -H "Content-Type: application/json" \
          --data '{
            "instance_id" : "<instance-id>"
          }'
        ```

=== "Vultr CLI"

    1. List all reserved IPs in your Vultr account and note the target reserved IP's ID.

        ```console
        $ vultr-cli reserved-ip list
        ```

    1. List all available instances and note your target instance's ID.

        ```console
        $ vultr-cli instance list
        ```

    1. Attach the reserved IP to the instance.

        ```console
        $ vultr-cli reserved-ip attach <reserved-ip-id> --instance-id <instance-id>
        ```

=== "Terraform"

    1. Open your Terraform configuration for the existing Cloud Compute instance.

    1. Add the `vultr_reserved_ip` resource and reference its `id` in the instance’s `reserved_ip_id` field.

        ```terraform
        resource "vultr_reserved_ip" "public_ip" {
            region = "del"
            ip_type = "v4"
            label   = "cc-reserved-ip"
        }

        resource "vultr_instance" "cc" {
            label           = "cc-instance-1"
            region          = "del"
            plan            = "vc2-2c-4gb"
            os_id           = 1743
            reserved_ip_id  = vultr_reserved_ip.public_ip.id
        }
        ```

    1. Apply the configuration and observe the following output:

        ```
        Apply complete! Resources: 1 added, 0 changed, 0 destroyed.
        ```
